#ifndef MAIN
#define MAIN

#include <header.h>

int DownloadFile(char url[MAXSTR],char Filename[MAXSTR]){
  CURLcode res;
  CURL *curl;
  FILE *file;
  long httpcode;

  #ifdef VERBOSE
  fprintf(stdout,"Getting: %s => %s \n",url,Filename);
  #endif //VERBOSE

  curl = curl_easy_init();
  if(!curl) {
	fprintf(stderr,"Error: %s\n","Can't Initialize CURL");
        curl_easy_cleanup(curl);
	return -1;
  }	

  
  file=fopen(Filename,"wb+");
  
  if(!file) {
	fprintf(stderr,"Error: %s %s\n","Can't Write to",Filename);
        curl_easy_cleanup(curl);
	return -1;
  }

  curl_easy_setopt(curl, CURLOPT_URL, url);
  curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, fwrite);
  curl_easy_setopt(curl, CURLOPT_WRITEDATA, file);

  res = curl_easy_perform(curl); 
  if(res!=CURLE_OK) {
    fprintf(stderr,"Error: %s\n",curl_easy_strerror(res));
    fclose(file);
    remove(Filename);
    curl_easy_cleanup(curl);
    return -1;	
  }	

  curl_easy_getinfo( curl, CURLINFO_HTTP_CODE, &httpcode);
  if(httpcode!=200) {
    fprintf(stderr,"Error: %s %ld\n","HTTP Status",httpcode);
    fclose(file);
    remove(Filename);
    curl_easy_cleanup(curl);
    if(httpcode>=400) return 1;	
    return -1; 
  } 	

  fclose(file);

  curl_easy_cleanup(curl); 
  return 0;	
}

int main(void)
{
  int i=1,done=0,tries,status;
  char URL[MAXSTR];
  char Filename[MAXSTR];
  char Filenamepath[MAXSTR];
  while(!done){
    sprintf(Filename,FILENAME,i++);
    sprintf(URL,"%s%s%s",SITE,URI,Filename);
    status=-1;tries=0;
    sprintf(Filenamepath,"%s%s",CACHEDIR,Filename);
    while(status==-1&&tries<TRIES) {
    status=DownloadFile(URL,Filenamepath); ++tries;  
    }
    if(status==1) ++done;
    if(tries==TRIES) ++done;
  }
  return 0;
}

#endif //MAIN
